package com.madeu.controller.web.webphotodiet;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webphotodiet.WebPhotoDietService;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;

@Slf4j
@Controller
public class WebPhotoDietController extends ManagerDraftAction {

    @Autowired
    private WebPhotoDietService webPhotoDietService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 홈페이지 전후사진(다이어트) 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/selectListWebPhotoDietIntro.do")
    public String  selectListWebPhotoDietIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebPhotoDietController  selectListWebPhotoDietIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webPhotoDietService.selectListWebPhotoDietIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebPhotoDietController  selectListWebPhotoDietIntro END");
        return "/web/webphotodiet/webPhotoDietSelectList";
    }

    /**
     * 홈페이지 전후사진(다이어트) 정보 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/selectListWebPhotoDiet.do")
    public ModelAndView selectListWebPhotoDiet(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebPhotoDietController selectListWebPhotoDiet START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webPhotoDietService.selectListWebPhotoDiet(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebPhotoDietController selectListWebPhotoDiet END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 홈페이지 전후사진(다이어트) 정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/selectWebPhotoDiet.do")
    public ModelAndView selectWebPhotoDiet(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebPhotoDietController selectWebPhotoDiet START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webPhotoDietService.selectWebPhotoDiet(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebPhotoDietController selectWebPhotoDiet END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 홈페이지 전후사진(다이어트) 상세 이미지 파일 저장
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/uploadFile.do")
    public ModelAndView uploadFile(HttpSession session,HttpServletRequest request, HttpServletResponse response,@RequestParam(value = "file", required = false) MultipartFile file) {
        log.debug("WebPhotoDietController uploadFile START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webPhotoDietService.uploadFile(paramMap,file);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webphotodiet/uploadFile.do");
                insertMap.put("func", "uploadFile");
                insertMap.put("funcName", "홈페이지 전후사진(다이어트) 상세 이미지파일 저장");
                insertMap.put("service", "webPhotoDietService");
                insertMap.put("serviceName", "홈페이지 전후사진(다이어트) 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebPhotoDietController uploadFile END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    /**
     * 홈페이지 전후사진(다이어트) 등록 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/insertWebPhotoDietIntro.do")
    public String  insertWebPhotoDietIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebPhotoDietController  insertWebPhotoDietIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webPhotoDietService.insertWebPhotoDietIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
                model.addAttribute("categorylist", map.get("categorylist"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  insertWebPhotoDietIntro END");
        return "/web/webphotodiet/webPhotoDietInsert";
    }

    /**
     * 홈페이지 전후사진(다이어트) 정보 등록
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/insertWebPhotoDiet.do")
    public ModelAndView insertWebPhotoDiet(HttpSession session, HttpServletRequest request, HttpServletResponse response,
                                           @RequestParam(value = "beforeFile", required = false) MultipartFile beforeFile,
                                           @RequestParam(value = "afterFile", required = false) MultipartFile afterFile) {
        log.debug("WebPhotoDietController insertWebPhotoDiet START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                List<MultipartFile> files = new ArrayList<>();
                files.add(beforeFile);
                files.add(afterFile);
                map = ((WebPhotoDietService)webPhotoDietService).insertWebPhotoDiet(paramMap, files);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webphotodiet/insertWebPhotoDiet.do");
                insertMap.put("func", "insertWebPhotoDiet");
                insertMap.put("funcName", "홈페이지 전후사진(다이어트) 등록");
                insertMap.put("service", "webPhotoDietService");
                insertMap.put("serviceName", "홈페이지 전후사진(다이어트) 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebPhotoDietController insertWebPhotoDiet END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 홈페이지 전후사진(다이어트) 수정 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/updateWebPhotoDietIntro.do")
    public String  updateWebPhotoDietIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebPhotoDietController  updateWebPhotoDietIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webPhotoDietService.updateWebPhotoDietIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
                model.addAttribute("categorylist", map.get("categorylist"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  updateWebPhotoDietIntro END");
        return "/web/webphotodiet/webPhotoDietUpdate";
    }

    /**
     * 홈페이지 전후사진(다이어트) 정보 수정
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/updateWebPhotoDiet.do")
    public ModelAndView updateWebPhotoDiet(HttpSession session, HttpServletRequest request, HttpServletResponse response,
                                           @RequestParam(value = "beforeFile", required = false) MultipartFile beforeFile,
                                           @RequestParam(value = "afterFile", required = false) MultipartFile afterFile) {
        log.debug("WebPhotoDietController updateWebPhotoDiet START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                List<MultipartFile> files = new java.util.ArrayList<>();
                files.add(beforeFile);
                files.add(afterFile);
                map = webPhotoDietService.updateWebPhotoDiet(paramMap, files);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webphotodiet/updateWebPhotoDiet.do");
                insertMap.put("func", "updateWebPhotoDiet");
                insertMap.put("funcName", "홈페이지 전후사진(다이어트) 수정");
                insertMap.put("service", "webPhotoDietService");
                insertMap.put("serviceName", "홈페이지 전후사진(다이어트) 수정");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebPhotoDietController updateWebPhotoDiet END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }


    /**
     * 홈페이지 전후사진(다이어트) 정보 삭제
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webphotodiet/deleteWebPhotoDiet.do")
    public ModelAndView deleteWebPhotoDiet(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebPhotoDietController deleteWebPhotoDiet START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webPhotoDietService.deleteWebPhotoDiet(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webphotodiet/deleteWebPhotoDiet.do");
                insertMap.put("func", "deleteWebPhotoDiet");
                insertMap.put("funcName", "홈페이지 전후사진(다이어트) 삭제");
                insertMap.put("service", "webPhotoDietService");
                insertMap.put("serviceName", "홈페이지 전후사진(다이어트) 삭제");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebPhotoDietController deleteWebPhotoDiet END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
}
